Index: modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java
===================================================================
--- modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java	(revision 61440)
+++ modules/uoa-repository-manager-service/trunk/src/main/java/eu/dnetlib/repo/manager/service/RepositoryServiceImpl.java	(revision 61441)
@@ -1,6 +1,9 @@
 package eu.dnetlib.repo.manager.service;
 
 import com.fasterxml.jackson.databind.ObjectMapper;
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
 import eu.dnetlib.api.functionality.ValidatorServiceException;
 import eu.dnetlib.domain.data.Repository;
 import eu.dnetlib.domain.data.RepositoryInterface;
@@ -7,7 +10,12 @@
 import eu.dnetlib.domain.enabling.Vocabulary;
 import eu.dnetlib.domain.functionality.validator.JobForValidation;
 import eu.dnetlib.repo.manager.domain.*;
+import eu.dnetlib.repo.manager.domain.dto.Role;
 import eu.dnetlib.repo.manager.exception.ResourceNotFoundException;
+import eu.dnetlib.repo.manager.service.aai.registry.AaiRegistryService;
+import eu.dnetlib.repo.manager.service.security.AuthoritiesUpdater;
+import eu.dnetlib.repo.manager.service.security.AuthorizationService;
+import eu.dnetlib.repo.manager.service.security.RoleMappingService;
 import eu.dnetlib.repo.manager.utils.Converter;
 import gr.uoa.di.driver.enabling.vocabulary.VocabularyLoader;
 import org.apache.commons.codec.digest.DigestUtils;
@@ -15,8 +23,10 @@
 import org.json.JSONArray;
 import org.json.JSONException;
 import org.json.JSONObject;
+import org.mitre.openid.connect.model.OIDCAuthenticationToken;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.beans.factory.annotation.Value;
+import org.springframework.context.annotation.Lazy;
 import org.springframework.core.ParameterizedTypeReference;
 import org.springframework.http.*;
 import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
@@ -23,6 +33,7 @@
 import org.springframework.security.core.Authentication;
 import org.springframework.security.core.context.SecurityContextHolder;
 import org.springframework.stereotype.Service;
+import org.springframework.web.client.HttpClientErrorException;
 import org.springframework.web.client.RestClientException;
 import org.springframework.web.client.RestTemplate;
 import org.springframework.web.util.UriComponents;
@@ -38,6 +49,18 @@
 @Service("repositoryService")
 public class RepositoryServiceImpl implements RepositoryService {
 
+    private static final Logger LOGGER = Logger.getLogger(RepositoryServiceImpl.class);
+
+    private final AuthorizationService authorizationService;
+    private final RoleMappingService roleMappingService;
+    private final AaiRegistryService registryCalls;
+    private final AuthoritiesUpdater authoritiesUpdater;
+    private final RestTemplate restTemplate;
+    private final VocabularyLoader vocabularyLoader;
+    private final PiWikService piWikService;
+    private final EmailUtils emailUtils;
+    private final ValidatorService validatorService;
+
     @Value("${api.baseAddress}")
     private String baseAddress;
 
@@ -44,15 +67,6 @@
     @Value("${services.repo-manager.adminEmail}")
     private String adminEmail;
 
-    @Autowired
-    RestTemplate restTemplate;
-
-    private HttpHeaders httpHeaders;
-
-    private final String[] vocabularyNames = {"dnet:countries", "dnet:datasource_typologies", "dnet:compatibilityLevel"};
-
-    private static final Logger LOGGER = Logger.getLogger(RepositoryServiceImpl.class);
-
     @Value("${services.repomanager.usageStatisticsDiagramsBaseURL}")
     private String usageStatisticsDiagramsBaseURL;
 
@@ -59,50 +73,65 @@
     @Value("${services.repomanager.usageStatisticsNumbersBaseURL}")
     private String usageStatisticsNumbersBaseURL;
 
-    @Autowired
-    private VocabularyLoader vocabularyLoader;
 
-    @Autowired
-    private PiWikService piWikService;
+    private static final Map<String, List<String>> dataSourceClass = new HashMap<>();
+    private static final Map<String, String> invertedDataSourceClass = new HashMap<>();
 
-    @Autowired
-    private EmailUtils emailUtils;
 
-    @Autowired
-    ValidatorService validatorService;
+    private final String[] vocabularyNames = {"dnet:countries", "dnet:datasource_typologies", "dnet:compatibilityLevel"};
+    private final Map<String, Vocabulary> vocabularyMap = new ConcurrentHashMap<>();
+    private final Map<String, String> countriesMap = new HashMap<>();
+    private final Map<String, String> inverseCountriesMap = new HashMap<>();
 
+    private HttpHeaders httpHeaders;
 
-    private Map<String, Vocabulary> vocabularyMap = new ConcurrentHashMap<>();
+    @Autowired
+    public RepositoryServiceImpl(AuthorizationService authorizationService,
+                                 RoleMappingService roleMappingService,
+                                 AaiRegistryService registryCalls,
+                                 AuthoritiesUpdater authoritiesUpdater,
+                                 VocabularyLoader vocabularyLoader,
+                                 RestTemplate restTemplate,
+                                 @Lazy EmailUtils emailUtils,
+                                 @Lazy ValidatorService validatorService,
+                                 @Lazy PiWikService piWikService) {
+        this.authorizationService = authorizationService;
+        this.roleMappingService = roleMappingService;
+        this.registryCalls = registryCalls;
+        this.authoritiesUpdater = authoritiesUpdater;
+        this.vocabularyLoader = vocabularyLoader;
+        this.piWikService = piWikService;
+        this.emailUtils = emailUtils;
+        this.validatorService = validatorService;
+        this.restTemplate = restTemplate;
+    }
 
-    private Map<String, String> countriesMap = new HashMap<>();
-    private Map<String, String> inverseCountriesMap = new HashMap<>();
+    private String getAuthenticatedUserEmail() {
+        OIDCAuthenticationToken authenticationToken = (OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication();
+        return authenticationToken.getUserInfo().getEmail();
+    }
 
-    private static Map<String,List<String>> dataSourceClass = new HashMap<>();
 
-    private static Map<String,String> invertedDataSourceClass = new HashMap<>();
-
-
-
     @PostConstruct
     private void init() {
         LOGGER.debug("Initialization method of repository api!");
         LOGGER.debug("Updated version!");
 
-        dataSourceClass.put("opendoar",Arrays.asList("pubsrepository::institutional","pubsrepository::thematic","pubsrepository::unknown","pubsrepository::mock"));
+        dataSourceClass.put("opendoar", Arrays.asList("pubsrepository::institutional", "pubsrepository::thematic", "pubsrepository::unknown", "pubsrepository::mock"));
         dataSourceClass.put("re3data", Collections.singletonList("datarepository::unknown"));
         dataSourceClass.put("journal", Collections.singletonList("pubsrepository::journal"));
-        dataSourceClass.put("aggregator",Arrays.asList("aggregator::pubsrepository::institutional","aggregator::pubsrepository::journals","aggregator::datarepository", "aggregator::pubsrepository::unknown"));
+        dataSourceClass.put("aggregator", Arrays.asList("aggregator::pubsrepository::institutional", "aggregator::pubsrepository::journals", "aggregator::datarepository", "aggregator::pubsrepository::unknown"));
 
-        invertedDataSourceClass.put("pubsrepository::institutional","opendoar");
-        invertedDataSourceClass.put("pubsrepository::thematic","opendoar");
-        invertedDataSourceClass.put("pubsrepository::unknown","opendoar");
-        invertedDataSourceClass.put("pubsrepository::mock","opendoar");
-        invertedDataSourceClass.put("datarepository::unknown","re3data");
-        invertedDataSourceClass.put("pubsrepository::journal","journal");
-        invertedDataSourceClass.put("aggregator::pubsrepository::institutional","aggregator");
-        invertedDataSourceClass.put("aggregator::pubsrepository::journals","aggregator");
-        invertedDataSourceClass.put("aggregator::datarepository","aggregator");
-        invertedDataSourceClass.put("aggregator::pubsrepository::unknown","aggregator");
+        invertedDataSourceClass.put("pubsrepository::institutional", "opendoar");
+        invertedDataSourceClass.put("pubsrepository::thematic", "opendoar");
+        invertedDataSourceClass.put("pubsrepository::unknown", "opendoar");
+        invertedDataSourceClass.put("pubsrepository::mock", "opendoar");
+        invertedDataSourceClass.put("datarepository::unknown", "re3data");
+        invertedDataSourceClass.put("pubsrepository::journal", "journal");
+        invertedDataSourceClass.put("aggregator::pubsrepository::institutional", "aggregator");
+        invertedDataSourceClass.put("aggregator::pubsrepository::journals", "aggregator");
+        invertedDataSourceClass.put("aggregator::datarepository", "aggregator");
+        invertedDataSourceClass.put("aggregator::pubsrepository::unknown", "aggregator");
 
 
         httpHeaders = new HttpHeaders();
@@ -128,9 +157,86 @@
                 .build().encode();
         return restTemplate.getForObject(uriComponents.toUri(), Country[].class);
     }
+    
+    // FIXME: with the new roles of the users the "requestFilter.setRegisteredby(userEmail)" can no longer be used
+    //  and the "requestFilter.setId(repoId)" should return only one result at a time, thus,
+    //  another way for paging must be implemented.
+    @Override
+    public List<Repository> getRepositories(List<String> ids) throws JSONException {
+        return getRepositories(ids, 0, 10);
+    }
 
+    // FIXME: with the new roles of the users the "requestFilter.setRegisteredby(userEmail)" can no longer be used
+    //  and the "requestFilter.setId(repoId)" should return only one result at a time, thus,
+    //  another way for paging must be implemented.
+    @Override
+    public List<Repository> getRepositories(List<String> ids, int page, int size) throws JSONException {
+        List<Repository> repos = new ArrayList<>();
+        LOGGER.debug("Retreiving repositories with ids : " + String.join(", ", ids));
+        UriComponents uriComponents = searchDatasource(Integer.toString(Math.abs(page)), Integer.toString(Math.abs(size)));
+        RequestFilter requestFilter = new RequestFilter();
 
+        try {
+            for (String repoId : ids) {
+                requestFilter.setId(repoId);
+                String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
+
+                repos.addAll(Converter.jsonToRepositoryList(new JSONObject(rs)));
+            }
+        } catch (JSONException e) {
+            LOGGER.debug("Exception on getRepositoriesOfUser", e);
+            emailUtils.reportException(e);
+            throw e;
+        }
+
+        for (Repository r : repos)
+            r.setPiwikInfo(piWikService.getPiwikSiteForRepo(r.getId()));
+        return repos;
+    }
+
+    // FIXME: with the new roles of the users the "requestFilter.setRegisteredby(userEmail)" can no longer be used
+    //  and the "requestFilter.setId(repoId)" should return only one result at a time, thus,
+    //  another way for paging must be implemented.
     @Override
+    public List<RepositorySnippet> getRepositoriesSnippets(List<String> ids) throws Exception {
+        return getRepositoriesSnippets(ids, 0, 10);
+    }
+
+    // FIXME: with the new roles of the users the "requestFilter.setRegisteredby(userEmail)" can no longer be used
+    //  and the "requestFilter.setId(repoId)" should return only one result at a time, thus,
+    //  another way for paging must be implemented.
+    @Override
+    public List<RepositorySnippet> getRepositoriesSnippets(List<String> ids, int page, int size) throws Exception {
+        List<RepositorySnippet> resultSet = new ArrayList<>();
+        ObjectMapper mapper = new ObjectMapper();
+
+        // here page should be 0
+        UriComponents uriComponents = searchSnipperDatasource(Integer.toString(Math.abs(page)), Integer.toString(Math.abs(size)));
+        RequestFilter requestFilter = new RequestFilter();
+
+        try {
+            for (String repoId : ids) {
+                requestFilter.setId(repoId);
+
+                String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
+                JSONArray jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
+                resultSet.addAll(mapper.readValue(String.valueOf(jsonArray),
+                        mapper.getTypeFactory().constructCollectionType(List.class, RepositorySnippet.class)));
+            }
+        } catch (Exception e) {
+            LOGGER.debug("Exception on getRepositoriesSnippetOfUser", e);
+            throw e;
+        }
+
+        LOGGER.debug("resultSet:" + resultSet);
+        resultSet.parallelStream().forEach(repositorySnippet -> {
+            repositorySnippet.setPiwikInfo(piWikService.getPiwikSiteForRepo(repositorySnippet.getId()));
+        });
+        return resultSet;
+    }
+
+
+    @Override
     public List<RepositorySnippet> getRepositoriesByCountry(String country,
                                                             String mode,
                                                             Boolean managed) throws JSONException, IOException {
@@ -151,25 +257,25 @@
         LOGGER.debug("Country code equals : " + country);
         LOGGER.debug("Filter mode equals : " + filterKey);
 
-        UriComponents uriComponents = searchSnipperDatasource(String.valueOf(page),String.valueOf(size));
+        UriComponents uriComponents = searchSnipperDatasource(String.valueOf(page), String.valueOf(size));
         RequestFilter requestFilter = new RequestFilter();
         requestFilter.setCountry(country);
         requestFilter.setCollectedfrom(filterKey);
 
-        try{
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+        try {
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             JSONArray jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
-            while (jsonArray.length() > 0 ) {
+            while (jsonArray.length() > 0) {
                 resultSet.addAll(mapper.readValue(String.valueOf(jsonArray),
                         mapper.getTypeFactory().constructCollectionType(List.class, RepositorySnippet.class)));
                 page += 1;
-                uriComponents = searchSnipperDatasource(String.valueOf(page),String.valueOf(size));
-                rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+                uriComponents = searchSnipperDatasource(String.valueOf(page), String.valueOf(size));
+                rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
                 jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
             }
             return resultSet;
-        }catch (Exception e){
-            LOGGER.debug("Exception on getRepositoriesByCountry" , e);
+        } catch (Exception e) {
+            LOGGER.debug("Exception on getRepositoriesByCountry", e);
 //            emailUtils.reportException(e);
             throw e;
         }
@@ -176,7 +282,7 @@
     }
 
     public List<RepositorySnippet> searchRegisteredRepositories(String country, String typology, String englishName,
-            String officialName, String requestSortBy, String order, int page, int pageSize) throws Exception {
+                                                                String officialName, String requestSortBy, String order, int page, int pageSize) throws Exception {
 
         LOGGER.debug("Searching registered repositories");
 
@@ -192,14 +298,14 @@
         requestFilter.setEnglishname(englishName);
 
         try {
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             JSONArray jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
 
-            resultSet.addAll(mapper.readValue(String.valueOf(jsonArray),  mapper.getTypeFactory().constructCollectionType(List.class, RepositorySnippet.class)));
+            resultSet.addAll(mapper.readValue(String.valueOf(jsonArray), mapper.getTypeFactory().constructCollectionType(List.class, RepositorySnippet.class)));
 
-             return resultSet;
-        }catch (Exception e){
-            LOGGER.error("Error searching registered datasources" , e);
+            return resultSet;
+        } catch (Exception e) {
+            LOGGER.error("Error searching registered datasources", e);
             throw e;
         }
     }
@@ -207,9 +313,9 @@
     private Repository updateRepositoryInfo(Repository r) throws JSONException {
 
         /*
-        * from datasource class
-        * we get the datasource type form the inverted map
-        * */
+         * from datasource class
+         * we get the datasource type form the inverted map
+         * */
         r.setDatasourceType(getRepositoryType(r.getDatasourceClass()));
         r.setInterfaces(this.getRepositoryInterface(r.getId()));
         r.setPiwikInfo(piWikService.getPiwikSiteForRepo(r.getId()));
@@ -230,79 +336,78 @@
     }
 
     @Override
-    public List<Repository> getRepositoriesOfUser(String userEmail,
-                                                  String page,
-                                                  String size) throws JSONException {
+    public List<Repository> getRepositoriesOfUser(String page, String size) throws JSONException {
+        String userEmail = ((OIDCAuthenticationToken) SecurityContextHolder.getContext().getAuthentication()).getUserInfo().getEmail();
+        LOGGER.debug("Retreiving repositories of authenticated user : " + userEmail);
+        Collection<String> repoIds = roleMappingService.getRepoIdsByRoleIds(authorizationService.getUserRoles());
+        return getRepositories(new ArrayList<>(repoIds));
+    }
 
-        LOGGER.debug("Retreiving repositories of user : " + userEmail );
-        UriComponents uriComponents = searchDatasource(page,size);
-        RequestFilter requestFilter = new RequestFilter();
-        requestFilter.setRegisteredby(userEmail);
+    @Override
+    public List<Repository> getRepositoriesOfUser(String userEmail, String page, String size) throws JSONException {
+        LOGGER.debug("Retreiving repositories of authenticated user : " + userEmail);
+        Collection<String> repoIds = roleMappingService.getRepoIdsByRoleIds(authorizationService.getUserRoles(userEmail));
+        return getRepositories(new ArrayList<>(repoIds));
+    }
 
-        try{
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+    @Override
+    public List<RepositorySnippet> getRepositoriesSnippetsOfUser(String page, String size) throws Exception {
+        Collection<String> repoIds = roleMappingService.getRepoIdsByRoleIds(authorizationService.getUserRoles());
+        return getRepositoriesSnippets(new ArrayList<>(repoIds));
+    }
 
-            List<Repository> repos = Converter.jsonToRepositoryList(new JSONObject(rs));
-            for (Repository r : repos)
-                r.setPiwikInfo(piWikService.getPiwikSiteForRepo(r.getId()));
-            return repos;
-        }catch (Exception e){
-            LOGGER.debug("Exception on getRepositoriesOfUser" , e);
-            emailUtils.reportException(e);
-            throw e;
-        }
+    @Override
+    public List<RepositorySnippet> getRepositoriesSnippetsOfUser(String userEmail, String page, String size) throws Exception {
+        Collection<String> repoIds = roleMappingService.getRepoIdsByRoleIds(authorizationService.getUserRoles(userEmail));
+        return getRepositoriesSnippets(new ArrayList<>(repoIds));
     }
 
     @Override
-    public List<RepositorySnippet> getRepositoriesSnippetOfUser(String userEmail, String page, String size) throws IOException, JSONException {
-        List<RepositorySnippet> resultSet = new ArrayList<>();
-        ObjectMapper mapper = new ObjectMapper();
+    public RepositorySnippet getRepositorySnippetById(String id) throws JSONException, ResourceNotFoundException {
 
-        UriComponents uriComponents = searchSnipperDatasource(page,size);
+        LOGGER.debug("Retreiving repositories with id : " + id);
+        RepositorySnippet repo = null;
+        UriComponents uriComponents = searchSnipperDatasource("0", "100");
         RequestFilter requestFilter = new RequestFilter();
-        requestFilter.setRegisteredby(userEmail);
+        requestFilter.setId(id);
 
-        try{
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+        try {
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             JSONArray jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
-            while (jsonArray.length() > 0 ) {
-                resultSet.addAll(mapper.readValue(String.valueOf(jsonArray),
-                        mapper.getTypeFactory().constructCollectionType(List.class, RepositorySnippet.class)));
-                page += 1;
-                uriComponents = searchSnipperDatasource(page,size);
-                rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
-                jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
-            }
-            resultSet.parallelStream().forEach(repositorySnippet -> {
-                repositorySnippet.setPiwikInfo(piWikService.getPiwikSiteForRepo(repositorySnippet.getId()));
-            });
-            return resultSet;
-        }catch (Exception e){
-            LOGGER.debug("Exception on getRepositoriesByCountry" , e);
+
+            if (jsonArray.length() == 0)
+                throw new ResourceNotFoundException();
+
+            repo = Converter.jsonToRepositorySnippetObject(jsonArray.getJSONObject(0));
+            return repo;
+        } catch (JSONException e) {
+            LOGGER.debug("Exception on getRepositoryById", e);
+            emailUtils.reportException(e);
             throw e;
         }
+
     }
 
     @Override
-    public Repository getRepositoryById(String id) throws JSONException,ResourceNotFoundException {
+    public Repository getRepositoryById(String id) throws JSONException, ResourceNotFoundException {
 
-        LOGGER.debug("Retreiving repositories with id : " + id );
+        LOGGER.debug("Retreiving repositories with id : " + id);
         Repository repo = null;
-        UriComponents uriComponents = searchDatasource("0","100");
+        UriComponents uriComponents = searchDatasource("0", "100");
         RequestFilter requestFilter = new RequestFilter();
         requestFilter.setId(id);
 
-        try{
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+        try {
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             JSONArray jsonArray = (JSONArray) new JSONObject(rs).get("datasourceInfo");
 
-            if(jsonArray.length() == 0)
+            if (jsonArray.length() == 0)
                 throw new ResourceNotFoundException();
 
             repo = Converter.jsonToRepositoryObject(jsonArray.getJSONObject(0));
             return updateRepositoryInfo(repo);
-        }catch (JSONException e){
-            LOGGER.debug("Exception on getRepositoryById" , e);
+        } catch (JSONException e) {
+            LOGGER.debug("Exception on getRepositoryById", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -313,8 +418,8 @@
     @Override
     public List<AggregationDetails> getRepositoryAggregations(String id, int from, int size) throws JSONException {
 
-        LOGGER.debug("Retreiving aggregations for repository with id : " + id );
-        UriComponents uriComponents = searchDatasource(from+"",size+"");
+        LOGGER.debug("Retreiving aggregations for repository with id : " + id);
+        UriComponents uriComponents = searchDatasource(from + "", size + "");
         RequestFilter requestFilter = new RequestFilter();
         requestFilter.setId(id);
 
@@ -322,13 +427,13 @@
 
         try {
             long start = System.currentTimeMillis();
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             long end = System.currentTimeMillis();
 
-            System.out.println("Aggregations request through rest template took " + (end-start)+"ms");
+            System.out.println("Aggregations request through rest template took " + (end - start) + "ms");
             JSONObject repository = new JSONObject(rs);
 
-            if(repository.getJSONArray("datasourceInfo").length() == 0)
+            if (repository.getJSONArray("datasourceInfo").length() == 0)
                 return aggregationHistory;
 
             start = System.currentTimeMillis();
@@ -335,13 +440,13 @@
             aggregationHistory.addAll(Converter.getAggregationHistoryFromJson(repository.getJSONArray("datasourceInfo").getJSONObject(0)));
             end = System.currentTimeMillis();
 
-            System.out.println("Getting aggregations history from json " + (end-start)+"ms");
-            return aggregationHistory.size() == 0? aggregationHistory : aggregationHistory.stream()
-                                                    .sorted(Comparator.comparing(AggregationDetails::getDate).reversed())
-                                                    .limit(size)
-                                                    .collect(Collectors.toList());
+            System.out.println("Getting aggregations history from json " + (end - start) + "ms");
+            return aggregationHistory.size() == 0 ? aggregationHistory : aggregationHistory.stream()
+                    .sorted(Comparator.comparing(AggregationDetails::getDate).reversed())
+                    .limit(size)
+                    .collect(Collectors.toList());
         } catch (JSONException e) {
-            LOGGER.debug("Exception on getRepositoryAggregations" , e);
+            LOGGER.debug("Exception on getRepositoryAggregations", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -350,8 +455,8 @@
 
     @Override
     public Map<String, List<AggregationDetails>> getRepositoryAggregationsByYear(String id) throws JSONException {
-        LOGGER.debug("Retreiving aggregations (by year) for repository with id : " + id );
-        UriComponents uriComponents = searchDatasource("0","100");
+        LOGGER.debug("Retreiving aggregations (by year) for repository with id : " + id);
+        UriComponents uriComponents = searchDatasource("0", "100");
         RequestFilter requestFilter = new RequestFilter();
         requestFilter.setId(id);
 
@@ -358,30 +463,30 @@
         List<AggregationDetails> aggregationHistory = new ArrayList<>();
         Map<String, List<AggregationDetails>> aggregationByYear = new HashMap<>();
         try {
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             JSONObject repository = new JSONObject(rs);
 
-            if(repository.getJSONArray("datasourceInfo").length() == 0)
+            if (repository.getJSONArray("datasourceInfo").length() == 0)
                 return aggregationByYear;
 
             aggregationHistory.addAll(Converter.getAggregationHistoryFromJson(repository.getJSONArray("datasourceInfo").getJSONObject(0)));
-            return aggregationHistory.size() == 0? aggregationByYear:createYearMap(aggregationHistory);
+            return aggregationHistory.size() == 0 ? aggregationByYear : createYearMap(aggregationHistory);
 
         } catch (JSONException e) {
-            LOGGER.debug("Exception on getRepositoryAggregations" , e);
+            LOGGER.debug("Exception on getRepositoryAggregations", e);
             emailUtils.reportException(e);
             throw e;
         }
     }
 
-    private Map<String,List<AggregationDetails>> createYearMap(List<AggregationDetails> aggregationHistory) {
+    private Map<String, List<AggregationDetails>> createYearMap(List<AggregationDetails> aggregationHistory) {
         Map<String, List<AggregationDetails>> aggregationByYear;
         aggregationHistory = aggregationHistory.stream()
-                            .sorted(Comparator.comparing(AggregationDetails::getDate).reversed())
-                            .collect(Collectors.toList());
+                .sorted(Comparator.comparing(AggregationDetails::getDate).reversed())
+                .collect(Collectors.toList());
 
-       return aggregationHistory.stream()
-                            .collect(Collectors.groupingBy(AggregationDetails::getYear));
+        return aggregationHistory.stream()
+                .collect(Collectors.groupingBy(AggregationDetails::getYear));
     }
 
 
@@ -390,19 +495,19 @@
                                                   String page,
                                                   String size) throws JSONException {
 
-        LOGGER.debug("Retreiving  repositories with official name : " + name );
-        UriComponents uriComponents = searchDatasource("0","100");
+        LOGGER.debug("Retreiving  repositories with official name : " + name);
+        UriComponents uriComponents = searchDatasource("0", "100");
         RequestFilter requestFilter = new RequestFilter();
         requestFilter.setOfficialname(name);
 
-        try{
-            String rs = restTemplate.postForObject(uriComponents.toUri(),requestFilter, String.class);
+        try {
+            String rs = restTemplate.postForObject(uriComponents.toUri(), requestFilter, String.class);
             List<Repository> repos = Converter.jsonToRepositoryList(new JSONObject(rs));
             for (Repository r : repos)
                 updateRepositoryInfo(r);
             return repos;
-        }catch (Exception e){
-            LOGGER.debug("Exception on getRepositoriesByName" , e);
+        } catch (Exception e) {
+            LOGGER.debug("Exception on getRepositoriesByName", e);
             emailUtils.reportException(e);
             throw e;
         }
@@ -417,11 +522,11 @@
                 .path("/{id}")
                 .build().expand(id).encode();
 
-        try{
+        try {
             String rs = restTemplate.getForObject(uriComponents.toUri(), String.class);
             return Converter.jsonToRepositoryInterfaceList(new JSONObject(rs));
-        }catch (Exception e ){
-            LOGGER.debug("Exception on getRepositoryInterface" , e);
+        } catch (Exception e) {
+            LOGGER.debug("Exception on getRepositoryInterface", e);
             emailUtils.reportException(e);
             throw e;
         }
